﻿using esoft.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace esoft.Class
{
    /// <summary>
    /// Класс для заполнения и работы с Исполнителями
    /// </summary>
    public class ExecuterFill : User
    {
        string grade; //Уровень Менеджера
        int managerID; //Менеджер которому подчиняется Исполнитель
        string fioUser; //ФИО Исполнителя

        public string Grade
        {
            get { return grade; }
            set { grade = value; }
        }
        public int ManagerID
        {
            get { return managerID; }
            set { managerID = value; }
        }
        public string FioUser
        {
            get { return fioUser; }
            set { fioUser = value; }
        }
        /// <summary>
        /// Метод формирующий удоный для работы список Исполнителей
        /// </summary>
        /// <returns>Список исполнителей</returns>
        public static List<ExecuterFill> Fill()
        {
            List<ExecuterFill> executerFills = new List<ExecuterFill>();
            try
            {
                
                List<Executor> executors = esoftEntities.GetContext().Executor.ToList();
                List<User> users = esoftEntities.GetContext().User.ToList();
                foreach (var user in users)
                {
                    foreach (var executer in executors)
                    {
                        if (user.ID == executer.ID)
                        {
                            executerFills.Add(new ExecuterFill
                            {
                                ID = user.ID,
                                Password = user.Password,
                                FirstName = user.FirstName,
                                MiddleName = user.MiddleName,
                                LastName = user.LastName,
                                Login = user.Login,
                                IsDeleted = user.IsDeleted,
                                FioUser = UserInFIO.SoloUser(user),
                                Grade = executer.Grade,
                                managerID = executer.ManagerID
                            });
                        }
                    }
                }
            }
            catch
            {
                MessageBox.Show("Ошибка заполнения списка Исполнителей",
                    "Ошибка",
                    MessageBoxButton.OK,
                    MessageBoxImage.Error);
            }
            return executerFills;
        }
    }
}
